/*
    dlggpureftpdimpl.h

    Copyright (c) 2006 by Xavier Facq

    gpureftpd (c) 2006 by the gpureftpd developers

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/


#ifndef DLGGPUREFTPDIMPL_H
#define DLGGPUREFTPDIMPL_H

#include "dlggpureftpd.h"

#include <qmessagebox.h>

class DlgGPureftpdImpl: public DlgGPureftpd
{
Q_OBJECT
public:
    DlgGPureftpdImpl(QWidget *parent = 0, const char *name = 0);

	int messageBox(QString caption, QString text,  QMessageBox::Icon icon, int button0 = QMessageBox::Ok, int button1 = 0, int button2 = 0);
	static int messageBox(QWidget *parent, QString caption, QString text,  QMessageBox::Icon icon, int button0 = QMessageBox::Ok, int button1 = 0, int button2 = 0);

public slots:
    void accept();
    void reject();
    void selectFile();
    void addAuthMethod();
    void removeAuthMethod();
    void updateAuthMethod();
    void setAllAnonymousOptionsDisabled(bool state);
    void setAllAuthenticateOptionsDisabled(bool state);
	void somethingChangeSomewhere(const QString& newText);
	void somethingChangeSomewhere(bool on);
	bool verifyIpAdress();
    void manageVirtualUsers();

private:
	bool m_UserCanSave;
	bool m_SomethingHaveChanged;

	QString readOptionFile(QString optionName);
	bool isOptionActive(QString optionName, bool bDefaultValue);
	bool toBoolean(QString optionName);
	int getIntValue(QString optionName, int nDefaultValue);
	bool saveConfiguration();
	bool writeFileOption(QString spath, QString sfilename, QString content);
	bool removeFileOption(QString path, QString sfilename);
	bool proceedBoolOption(QString optionName, bool state);
	bool proceedStringOption(QString optionName, QString content);
};

#endif
