/*
    dlgvirtualusersimpl.h

    Copyright (c) 2006 by Xavier Facq

    gpureftpd (c) 2006 by the gpureftpd developers

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/


#ifndef DLGVIRTUALUSERSIMPL_H
#define DLGVIRTUALUSERSIMPL_H

#include "virtualuser.h"
#include "dlgvirtualusers.h"

#include <qptrlist.h>
#include <qlistview.h>

class DlgVirtualUsersImpl: public DlgVirtualUsers
{
Q_OBJECT
public:
    DlgVirtualUsersImpl(QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0);

public slots:
	void accept();
	void reject();
	void showUserInfo(QListViewItem *);
	void enterPassword();
	void addVirtualUser();
	void removeVirtualUser();
	void controlChangeInDetailsZone();
	void somethingChangeSomewhere(bool on);
	void somethingChangeSomewhere(const QString& newText);

protected:
	bool m_DetailsChanged;
	bool m_SomethingHaveChanged;
	QPtrList<VirtualUser>* m_VirtualUserList;

	void fillListView();
	void clearDetailsZone();
	bool checkUncompletUsersData();
	void writePureftpdPasswdFile();
	bool loadVirtualUsersFromFile();
	void rebuildPureftpdPdbDatabase();
	VirtualUser* getByLogin(QString login);
	void synchronizeDetailsFromList(VirtualUser *vu);
	void synchronizeListFromDetails(VirtualUser *vu);
};

#endif
