/*
    virtualuser.cpp

    Copyright (c) 2006 by Xavier Facq

    gpureftpd (c) 2006 by the gpureftpd developers

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/


#include "virtualuser.h"

VirtualUser::VirtualUser()
{
}

/*
<account>:0
<password>:1
<uid>:2
<gid>:3
<gecos>:4
<home directory>:5
<upload bandwidth>:6
<download bandwidth>:7
<upload ratio>:8
<download ratio>:9
<max number of connections>:10
<files quota>:11
<size quota>:12
<authorized local IPs>:13
<refused local IPs>:14
<authorized client IPs>:15
<refused client IPs>:16
<time restrictions>17
*/

VirtualUser::VirtualUser(QString s)
{
	m_login = s.section(":", 0, 0);
	m_password = s.section(":",1, 1);
	m_UID = s.section(":", 2, 2);
	m_GID = s.section(":", 3, 3);
	m_FullName = s.section(":", 4, 4);
	m_Directory = s.section(":", 5, 5);
	m_UploadBandwidth = s.section(":", 6, 6);
	m_dwlBandwidth = s.section(":", 7, 7);
	m_UploadRatio = s.section(":", 8, 8);
	m_DownloadRatio = s.section(":", 9, 9);
	m_MaxSimSessions = s.section(":", 10, 10);
	m_MaxFiles = s.section(":", 11, 11);
	m_MaxSize = s.section(":", 12, 12);
	m_AllowedlocalIPs = s.section(":", 13, 13);
	m_DeniedLocalIPs = s.section(":", 14, 14);
	m_AllowedClientIPs = s.section(":", 15, 15);
	m_DeniedClientIPs = s.section(":", 16, 16);
	m_TimeRestrictions = s.section(":", 17, 17);
}

QString VirtualUser::getLogin() { return m_login; }
QString VirtualUser::getPassword() { return m_password; }
QString VirtualUser::getUID() { return m_UID; }
QString VirtualUser::getGID() { return m_GID; }
QString VirtualUser::getFullName() { return m_FullName; }
QString VirtualUser::getDirectory() { return m_Directory; }
QString VirtualUser::getUploadBandwidth() { return m_UploadBandwidth; }
QString VirtualUser::getdwlBandwidth() { return m_dwlBandwidth; }
QString VirtualUser::getRatio() { return m_UploadRatio + ":" + m_DownloadRatio; }
QString VirtualUser::getMaxSimSessions() { return m_MaxSimSessions; }
QString VirtualUser::getMaxFiles() { return m_MaxFiles; }
QString VirtualUser::getMaxSize() { return m_MaxSize; }
QString VirtualUser::getAllowedlocalIPs() { return m_AllowedlocalIPs; }
QString VirtualUser::getDeniedLocalIPs() { return m_DeniedLocalIPs; }
QString VirtualUser::getAllowedClientIPs() { return m_AllowedClientIPs; }
QString VirtualUser::getDeniedClientIPs() { return m_DeniedClientIPs; }
QString VirtualUser::getTimeRestrictions() { return m_TimeRestrictions; }

void VirtualUser::setLogin(QString s) {	m_login = s; }
void VirtualUser::setPassword(QString s) { m_password = s; }
void VirtualUser::setUID(QString s) { m_UID = s; }
void VirtualUser::setGID(QString s) { m_GID = s; }
void VirtualUser::setFullName(QString s) { m_FullName = s; }
void VirtualUser::setDirectory(QString s) { m_Directory = s; }
void VirtualUser::setUploadBandwidth(QString s) { m_UploadBandwidth = s; }
void VirtualUser::setdwlBandwidth(QString s) { m_dwlBandwidth = s; }

void VirtualUser::setRatio(QString s)
{
	m_UploadRatio = s.section(":", 0, 0);
	m_DownloadRatio = s.section(":", 1, 1);
}

void VirtualUser::setMaxSimSessions(QString s) { m_MaxSimSessions = s; }
void VirtualUser::setMaxFiles(QString s) { m_MaxFiles = s; }
void VirtualUser::setMaxSize(QString s) { m_MaxSize = s; }
void VirtualUser::setAllowedlocalIPs(QString s) { m_AllowedlocalIPs = s; }
void VirtualUser::setDeniedLocalIPs(QString s) { m_DeniedLocalIPs = s; }
void VirtualUser::setAllowedClientIPs(QString s) { m_AllowedClientIPs = s; }
void VirtualUser::setDeniedClientIPs(QString s) { m_DeniedClientIPs = s; }
void VirtualUser::setTimeRestrictions(QString s) { m_TimeRestrictions = s; }

QString VirtualUser::toString()
{
	QString ts;
	ts = m_login + ":" +
	m_password + ":" +
	m_UID + ":" +
	m_GID + ":" +
	m_FullName + ":" +
	m_Directory + ":" +
	m_UploadBandwidth + ":" +
	m_dwlBandwidth + ":" +
	m_UploadRatio + ":" + 
	m_DownloadRatio + ":" +
	m_MaxSimSessions + ":" +
	m_MaxFiles + ":" +
	m_MaxSize + ":" +
	m_AllowedlocalIPs + ":" +
	m_DeniedLocalIPs + ":" +
	m_AllowedClientIPs + ":" +
	m_DeniedClientIPs + ":" +
	m_TimeRestrictions + "\n";
	return ts;
}
