/*
    virtualuser.h

    Copyright (c) 2006 by Xavier Facq

    gpureftpd (c) 2006 by the gpureftpd developers

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/


#ifndef VIRTUALUSER_H
#define VIRTUALUSER_H

/*
Format du fichier /etc/pure-ftpd/pureftpd.passwd
xfacq:$1$M14LbnM0$DTFs0viY5FAMmsfOIEGeQ/:1001:1001::/home/ftp/./::::::::::::

correspond au infos suivantes :
Login              : xfacq
Password           : $1$M14LbnM0$DTFs0viY5FAMmsfOIEGeQ/
UID                : 1001 (ftpuser)
GID                : 1001 (ftpgroup)
Directory          : /home/ftp/./
Full name          :
Download bandwidth : 0 Kb (unlimited)
Upload   bandwidth : 0 Kb (unlimited)
Max files          : 0 (unlimited)
Max size           : 0 Mb (unlimited)
Ratio              : 0:0 (unlimited:unlimited)
Allowed local  IPs :
Denied  local  IPs :
Allowed client IPs :
Denied  client IPs :
Time restrictions  : 0000-0000 (unlimited)
Max sim sessions   : 0 (unlimited)

*/

#include "dlggpureftpd.h"

class VirtualUser
{
public:
    VirtualUser();
    VirtualUser(QString s);

	void setLogin(QString s);
	void setPassword(QString s);
	void setUID(QString s);
	void setGID(QString s);
	void setFullName(QString s);
	void setDirectory(QString s);
	void setUploadBandwidth(QString s);
	void setdwlBandwidth(QString s);
	void setRatio(QString s);
	void setMaxSimSessions(QString s);
	void setMaxFiles(QString s);
	void setMaxSize(QString s);
	void setAllowedlocalIPs(QString s);
	void setDeniedLocalIPs(QString s);
	void setAllowedClientIPs(QString s);
	void setDeniedClientIPs(QString s);
	void setTimeRestrictions(QString s);

	QString getLogin();
	QString getPassword();
	QString getUID();
	QString getGID();
	QString getDirectory();
	QString getFullName();
	QString getUploadBandwidth();
	QString getdwlBandwidth();
	QString getRatio();
	QString getMaxSimSessions();
	QString getMaxFiles();
	QString getMaxSize();
	QString getAllowedlocalIPs();
	QString getDeniedLocalIPs();
	QString getAllowedClientIPs();
	QString getDeniedClientIPs();
	QString getTimeRestrictions();

	QString toString();
protected:
	QString m_login;
	QString m_password;	
	QString m_UID;
	QString m_GID;
	QString m_Directory;
	QString m_FullName;
	QString m_dwlBandwidth;
	QString m_UploadBandwidth;
	QString m_MaxFiles;
	QString m_MaxSize;
	QString m_UploadRatio;
	QString m_DownloadRatio;
	QString m_AllowedlocalIPs;
	QString m_DeniedLocalIPs;
	QString m_AllowedClientIPs;
	QString m_DeniedClientIPs;
	QString m_TimeRestrictions;
	QString m_MaxSimSessions;
};

#endif
